package com.steerinfo.meterwork.meterworkcalibrationbranch.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.metermonitor.metermonitornote.model.MeterMonitorNote;
import com.steerinfo.meterwork.dto.CommonCombination;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkcalibrationbranch.model.MeterWorkCalibrationBranch;
import com.steerinfo.meterwork.meterworkcalibrationbranch.service.IMeterWorkCalibrationBranchService;
import com.steerinfo.meterwork.meterworkcalibrationmain.model.MeterWorkCalibrationMain;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkCalibrationBranch RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-09-25 02:54
 * 类描述
 * 修订历史：
 * 日期：2020-09-25
 * 作者：generator
 * 参考：
 * 描述：MeterWorkCalibrationBranch RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterworkcalibrationbranchs")
@Api(value = "/${api.version}/meterworkcalibrationbranchs", tags = "校秤记录数据从表 - MeterWorkCalibrationBranchController")
public class MeterWorkCalibrationBranchController extends BaseRESTfulController {

    @Autowired
    IMeterWorkCalibrationBranchService meterWorkCalibrationBranchService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkcalibrationbranch:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkCalibrationBranch> list = meterWorkCalibrationBranchService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkcalibrationbranch:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkCalibrationBranch> list = meterWorkCalibrationBranchService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkCalibrationBranch对象创建")
    @ApiImplicitParam(name = "meterWorkCalibrationBranch", value = "详细实体meterWorkCalibrationBranch", required = true, dataType = "MeterWorkCalibrationBranch")
    //@RequiresPermissions("meterworkcalibrationbranch:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkCalibrationBranch model) {
        try {
            MeterWorkCalibrationBranch meterWorkCalibrationBranch = meterWorkCalibrationBranchService.add(model);
            return success(meterWorkCalibrationBranch);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkcalibrationbranch:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterWorkCalibrationBranch meterWorkCalibrationBranch = meterWorkCalibrationBranchService.getById(id);
            return success(meterWorkCalibrationBranch);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterWorkCalibrationBranch信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterWorkCalibrationBranch", value = "详细实体meterWorkCalibrationBranch", required = true, dataType = "MeterWorkCalibrationBranch")
    })
    //@RequiresPermissions("meterworkcalibrationbranch:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkCalibrationBranch model) {
        try {
            model.setId(id);
            MeterWorkCalibrationBranch meterWorkCalibrationBranch = meterWorkCalibrationBranchService.modify(model);
            return success(meterWorkCalibrationBranch);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkcalibrationbranch:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterWorkCalibrationBranchService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "通过主表id获取数据列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkcalibrationbranch:view")
    @GetMapping(value = "/getByMainNo")
    public RESTfulResult getByMainNo(@RequestParam String calibrationMainNo, Integer pageNum, Integer pageSize) {
        RESTfulResult rm = failed();
        try {
            PageList<MeterWorkCalibrationBranch> pageInfo = meterWorkCalibrationBranchService.getByMainNo(calibrationMainNo, pageNum, pageSize);
            return success(pageInfo);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkCalibrationBranch对象创建")
    @ApiImplicitParam(name = "meterWorkCalibrationBranch", value = "详细实体meterWorkCalibrationBranch", required = true, dataType = "MeterWorkCalibrationBranch")
    //@RequiresPermissions("meterworkcalibrationbranch:create")
    @Transactional
    @PostMapping(value = "/doSaveWf")
    public RESTfulResult doSaveWf(@RequestBody CommonCombination<MeterWorkCalibrationMain, MeterWorkCalibrationBranch, MeterWorkCalibrationBranch, MeterMonitorNote> com) {
        RESTfulResult rm = failed();
        try {
            RESTfulResult resTfulResult = meterWorkCalibrationBranchService.doSaveWf(com.getOne(), com.getTwo());
            return resTfulResult;
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        }
        return rm;
    }

    @ApiOperation(value = "查询互检未完成的数据", notes = "根据url的实体集来指定删除对象")
    @PostMapping(value = "/selectForMutual")
    public RESTfulResult selectForMutual(@RequestBody MeterWorkCalibrationBranch model) {
        try {
            List<MeterWorkCalibrationBranch> mwcbs = meterWorkCalibrationBranchService.selectForMutual(model);
            return success(mwcbs);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

}
